unit Auto_pgm; {for DELPHI 2 and above ONLY}

interface

uses
  DisplayUnit, SEE, SEEW, KeyCode,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus;

type
  TAuto = class(TForm)
    eResult: TMemo;
    MainMenu1: TMainMenu;
    mRespond: TMenuItem;
    mExit: TMenuItem;
    procedure mExitClick(Sender: TObject);
    procedure mRespondClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Auto: TAuto;

implementation

{$R *.DFM}

procedure TAuto.mExitClick(Sender: TObject);
begin
  Application.Terminate
end;

procedure TAuto.mRespondClick(Sender: TObject);
label
  EXIT_AUTO;
const
  POP3_CHAN = 0;
  SMTP_CHAN = 1;
var
  I, N : Integer;
  Code : Integer;
  Len  : Integer;
  Build   : Integer;
  D1, D2, D3 : Integer;
  BuffPtr : PChar;
  Text    : String;
  Pop3Host : String;
  Pop3User : String;
  Pop3Pass : String;
  SmtpHost : String;
  SmtpFrom : String;
  SmtpReply : String;
  NbrMsg  : Integer;
  MsgSize : Integer;
  X, From : String;
  Empty   : String;
  Message : String;
  Pop3Connected : Boolean;
  SmtpConnected : Boolean;

function FirstNonPrintablePosition(S:String): Integer;
var
  I, Len : Integer;
  C : Char;
begin
  Len := Length(S);
  for I := 1 to Len do
    begin
      C := S[I];
      if not (IsCharAlphaNumeric(C) or (C='.') or (C='@') or (C='<') or (C='>')) then
        begin
          FirstNonPrintablePosition := I;
          exit
        end;
    end;
end;

begin
  {PROGRAMMER: Edit these strings as necessary}
  {setup SMTP and POP3 strings}
  Pop3Host := '10.0.0.1';
  Pop3User := 'mike';
  Pop3Pass := 'mike';
  SmtpHost := '10.0.0.1';
  SmtpFrom  := '<mike@10.0.0.1>'; {don't forget the angle brackets!}
  SmtpReply := '<mike@10.0.0.1>'; {don't forget the angle brackets!}
  {initialize}
  Pop3Connected := false;
  SmtpConnected := false;
  Empty := Chr(POP3_CHAN);
  Message := 'Your email was received.' + Chr(10) + Chr(13) + '-- Thanks!';
  DisplayLine(Auto.eResult,' Pop3Host = ' + Pop3Host);
  DisplayLine(Auto.eResult,' Pop3User = ' + Pop3User);
  DisplayLine(Auto.eResult,' Pop3Pass = ' + Pop3Pass);
  DisplayLine(Auto.eResult,' SmtpHost = ' + SmtpHost);
  DisplayLine(Auto.eResult,' SmtpFrom = ' + SmtpFrom);
  DisplayLine(Auto.eResult,'SmtpReply = ' + SmtpReply);
  {attach SEE (2 channels)}
  Code := fAttach(2, SEE_KEY_CODE);
  if Code < 0 then
    begin
      Text := Format('Cannot attach SEE (error %d)',[Code]);
      DisplayLine(auto.eResult, Text);
      exit;
    end;
  {show SEE version}
  Code := fStatistics(POP3_CHAN, SEE_GET_VERSION);
  D3 := $0F AND Code;  Code := Code SHR 4;
  D2 := $0F AND Code;  Code := Code SHR 4;
  D1 := $0F AND Code;
  Build := fStatistics(POP3_CHAN, SEE_GET_BUILD);
  Text := Format('SMTP/POP3 Email Engine Version %1d.%1d.%1d Build %d',
          [D1,D2,D3,Build]);
  DisplayLine(auto.eResult, Text);
  {define log files}
  Code := fStringParam(POP3_CHAN,  SEE_LOG_FILE, 'AUTOPOP3.LOG');
  Code := fStringParam(SMTP_CHAN,  SEE_LOG_FILE, 'AUTOSMTP.LOG');
  mRespond.Enabled := False;
  SCREEN.Cursor := crHourGlass;
  {connect to POP3 server}
  Code := fPop3Connect(POP3_CHAN,  Pop3Host, Pop3User, Pop3Pass);
  if Code < 0 then goto EXIT_AUTO;
  Pop3Connected := true;
  {connect to SMTP server}
  Code := fSmtpConnect(SMTP_CHAN,  SmtpHost, SmtpFrom, SmtpReply);
  if Code < 0 then goto EXIT_AUTO;
  SmtpConnected := true;
  {get # messages waiting on POP3 server}
  NbrMsg := fGetEmailCount(POP3_CHAN);
  if NbrMsg <=0 then goto EXIT_AUTO;
  DisplayLine(auto.eResult,Format('%d messages on server.', [NbrMsg]));
  { read message headers }
  for I := 1 to NbrMsg do
    begin
      {read message I}
      MsgSize := fGetEmailSize(POP3_CHAN, I);
      DisplayLine(auto.eResult,Format('message %d is %d bytes.',[I,MsgSize]));
      Code := fGetEmailLines(POP3_CHAN,  I, 0, Text);
      If Code < 0 then goto EXIT_AUTO;
      {display 'From: ' line}
      n := fExtractText(Text, 'From:', From);
      if n > 0 then
        begin
          Len := Length(From);
          X := Copy(From, 6, Len - 6);
          Len := FirstNonPrintablePosition(X);
          if Len > 0 then X := Copy(X, 1, Len - 1);
          if X[1] <> '<' then X := '<' + X + '>';
              {DisplayLine(auto.eResult,Format('%s', [X]));}
          {send email}
          Code := fSendEmail(SMTP_CHAN, X, Empty, Empty, 'Ackowledgment',Message,Empty);
          if Code < 0 then goto EXIT_AUTO;
          DisplayLine(auto.eResult, 'Email sent to ' + X)
       end;
    end;

EXIT_AUTO:

  if Code < 0 then DisplayError(auto.eResult,Code);
  mRespond.Enabled := True;
  SCREEN.Cursor := crDefault;
  DisplayLine(auto.eResult,'Done.');
  {close SEE}
  if(Pop3Connected) then fClose(POP3_CHAN);
  if(SmtpConnected) then fClose(SMTP_CHAN);
  fRelease
end;

end.
